#!/usr/bin/perl -w

##Usage: ./blockSim.pl
##AIM: give the distribution of block similarity
##Date:2011-06-15

use Getopt::Std;
getopt('iobn',\%opts);
unless(exists $opts{i} && exists $opts{o} && $opts{b} && exists $opts{n})
 {
	 die "Please specify:\n -i for input axt files, seperated by \",\"\n -o for output file\n -b for segment size\n -n for number of iterations\n";
 }


my $blockSize=$opts{b};
my $simulate=$opts{n};
my @inFileLs=split(/,/, $opts{i});


##------set output file
open OUTF1,">$opts{o}" or die $!;

##-------initiation
my $rseq;
my $qseq;
my $alignLen;
my $flag;
my $i;
my $j;

for(my $k=0;$k<$simulate;$k++){
	
	print "K=$k\n";

	################################hg19 to chimp pairwise alignment
	my @recHC=();
	for($i=0;$i<@inFileLs;$i++){
		open INF, "$inFileLs[$i]" or die $!;
		$flag=0;
		while(<INF>){
			chomp;
			##skip comment lines	
			next if($_ =~ /##/);
			$flag++;
			##---reference sequence
			if($flag == 2){
				$rseq=$_;
				$alignLen=length($_);			
			}
			##---query sequence
			$qseq=$_ if($flag == 3);
			
			##---initiation for next block
			if($flag == 4){
				$flag=0;
				if($alignLen>$blockSize){
					##---random pick one segments as representation
					my $range=$alignLen-$blockSize;
					my $randNum=int(rand($range));
					my $ct=0;
					for($j=0;$j<$blockSize;$j++){
						my $rnt=substr($rseq,($randNum+$j),1);
						my $qnt=substr($qseq,($randNum+$j),1);
						$ct++ if($rnt eq $qnt);
					}
					my $ratio=100*$ct/$blockSize;
					push(@recHC,$ratio);
				}
			}
		}
		close(INF);
	}	
		
		
	##output results
	my $output=join("\t",@recHC);
	print OUTF1 "$output\n";
}
close(OUTF1);

